/**
/* $Id: show.c,v 1.1 1998/02/13 08:56:14 falcon Exp $
/*  ORCUSSHOW.C  display and response functions for orcus  */
/**/

#include "includes.h"

void more_prompt() {
  char foo;
  extern int rows;
  extern int cols;
  extern int spat;

  if ( !rows ) return;
  if ( spat >= rows ) {
    printf ("[=more=]");
    fflush ( stdout );
    while (!fdpoll(0)) sleep(1);
    read ( 0, &foo, 1 );
    printf ("%c%c%c%c%c%c%c%c        %c%c%c%c%c%c%c%c",
             8,8,8,8,8,8,8,8,        8,8,8,8,8,8,8,8);
    fflush ( stdout );
    spat = 0;
    }
  }

void go_show_open_message ( stub, buf ) char *stub, *buf; { 
  char scratch[255];
  int  i, last_str, buflen, stublen, linelen, wrap;
  extern int cols;
  extern int spat;

  if ( !cols ) {
    printf ("<%s> %s\n", stub, buf );
    spat++;
    more_prompt();
    } else {
    wrap = 10;
    if ( cols < 35 ) wrap = 5;
    if ( cols > 45 ) wrap = 15;
    buflen  = strlen ( buf );
    stublen = strlen ( stub ) + 3;
    last_str  = 0;
    while ( buf[last_str] == ' ' ) last_str++;
    while ( ( buflen - last_str ) + stublen > cols ) {
      while ( buf[last_str] == ' ' ) last_str++;
      linelen = last_str - stublen + cols; 
      for ( i = linelen; ( i > linelen - wrap ) && ( buf[i] != ' ' ); i-- );
      strncpy ( scratch, buf + last_str, i - last_str );
      scratch[i-last_str] = 0;
      last_str = i;
      printf ("<%s> %s\n", stub, scratch);
      } /* end of while */
    while ( buf[last_str] == ' ' ) last_str++;
    if ( last_str < buflen ) 
       printf ("<%s> %s\n", stub, buf+last_str);
    } /* end of if */
  }

void go_show_pers_message ( stub, buf ) char *stub, *buf; { 
  char scratch[255];
  int  i, last_str, buflen, stublen, linelen, wrap;
  extern int cols;
  extern int spat;

  if ( !cols ) {
    printf ("<*%s*> %s\n", stub, buf );
    spat++;
    more_prompt();
    } else {
    wrap = 10;
    if ( cols < 35 ) wrap = 5;
    if ( cols > 45 ) wrap = 15;
    buflen  = strlen ( buf );
    stublen = strlen ( stub ) + 3;
    last_str  = 0;
    while ( buf[last_str] == ' ' ) last_str++;
    while ( ( buflen - last_str ) + stublen > cols ) {
      while ( buf[last_str] == ' ' ) last_str++;
      linelen = last_str - stublen + cols; 
      for ( i = linelen; ( i > linelen - wrap ) && ( buf[i] != ' ' ); i-- );
      strncpy ( scratch, buf + last_str, i - last_str );
      scratch[i-last_str] = 0;
      last_str = i;
      printf ("<*%s*> %s\n", stub, scratch);
      } /* end of while */
    while ( buf[last_str] == ' ' ) last_str++;
    if ( last_str < buflen ) 
       printf ("<*%s*> %s\n", stub, buf+last_str);
    } /* end of if */
  }

void go_show_status_update ( stub, buf ) char *stub, *buf; { 
  printf ("[=%s=] %s\n", stub, buf );
  }

void go_show_wholine ( buf ) char *buf; {
  int    i, j, k;
  char   nick[15];
  char   login[20];
  char   mach[128];
  char   dadate[30];
  int    idle;
  time_t timestamp;

  k    = strlen ( buf );    /* storing the length of original string */
  idle = 0;  timestamp = 0;
  for ( i = 0; i < k; i++ ) /* cutting up buf into substrings */
    if ( buf[i] == 1 ) buf[i] = 0;
  if ( buf[0] == 'm' ) printf (" *"); else printf ("  "); /* moderator? */
  j = 0; /* j indexes the destination string buffer */
  for ( i = 2; buf[i]; i++ ) { /* copying the user's nick */
    nick[j] = buf[i];  j++;  }
  nick[j] = 0; j = 0;          /* terminating nick[], resetting j */
  for ( i++; buf[i]; i++ ) {   /* extracting idle seconds */
    idle *= 10;
    idle += ( buf[i] - '0' );
    }
  for ( i++; buf[i]; i++ );    /* skipping next field; dunno what it does */
  for ( i++; buf[i]; i++ ) {   /* extracting timestamp of user's login */
    timestamp *= 10;
    timestamp += ( buf[i] - '0' );
    }
  for ( i++; buf[i]; i++ ) {   /* extracting user's account name */
    login[j] = buf[i]; j++; }
  login[j] = 0; j = 0;
  for ( i++; buf[i]; i++ ) {   /* extracting user's host system name */
    mach[j] = buf[i]; j++; }
  mach[j] = ' '; j++;
  for ( i++; buf[i]; i++ ) {   /* extracting unregistered field */
    mach[j] = buf[i]; j++; }
  mach[j] = 0; j = 0;  /* constructing time + date string */
  dadate[0]  = '0' + gmtime(&timestamp)->tm_mon / 10;
  dadate[1]  = '0' + gmtime(&timestamp)->tm_mon % 10;
  dadate[2]  = '/';
  dadate[3]  = '0' + gmtime(&timestamp)->tm_mday / 10;
  dadate[4]  = '0' + gmtime(&timestamp)->tm_mday % 10;
  dadate[5]  = ' ';
  dadate[6]  = '0' + gmtime(&timestamp)->tm_hour / 10;
  dadate[7]  = '0' + gmtime(&timestamp)->tm_hour % 10;
  dadate[8]  = ':';
  dadate[9]  = '0' + gmtime(&timestamp)->tm_min / 10;
  dadate[10] = '0' + gmtime(&timestamp)->tm_min % 10;
  dadate[11] = 0;
  printf ("%-12s %2dh %2dm %2ds   %s %s@%s\n",
          nick,(idle/3600),(idle/60)%60,idle%60,dadate,login,mach);
  }

void go_show_command_output ( stub, buf ) char *stub, *buf; { 

  extern int spat;

  if ( !strcmp ( "wh", stub ) ) 
     printf ("  Nick             Idle         Login\n");
  else if ( !strcmp ( "wl", stub ) ) 
     go_show_wholine ( buf );
  else printf ("%s\n", buf );
  spat++;
  more_prompt();
  }

void go_login_verified() { /* stuff[] not valid */
  printf ("[=login-verified=]\n");
  }

void go_we_must_exit() { /* stuff[] not valid */
  printf ("[=ORCUS=] The server has told us to exit.\n");
  orc_quit();
  }

void go_protocol_version() { /* stuff[] not valid */
  printf ("[=ORCUS=] Protocol verified with server.\n");
  }

void go_show_error(buf) char *buf; { 
  printf ("[=ERROR=] %s\n", buf );
  }

void go_announcement(buf) char *buf; { 
  printf ("[=ANNOUNCE=] %s\n", buf );
  }

void go_gotum_beep(buf) char *buf; 
{ 
  extern int nobeep;
  extern int bmessage;
  extern int breturn;
  extern int s;
  
  if ( !nobeep ) printf ("%c",7);
  if ( !nobeep || bmessage ) printf ("[=beep=] from %s\n", buf );
  if (  nobeep && breturn  ) 
     writepriv ( s, buf, "This user not accepting beeps" );
}

void go_gotum_ping(buf) char *buf; { 
  printf ("[=ping=] from %s\n", buf );
  }
